require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xdisk',
  dscmeta_resource_friendly_name: 'xDisk',
  dscmeta_resource_name: 'MSFT_xDisk',
  dscmeta_module_name: 'xDisk',
  dscmeta_module_version: '1.0',
  docs: 'The DSC xDisk resource type.
         Automatically generated from version 1.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_driveletter: {
      type: 'Optional[String]',
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_disknumber: {
      type: 'Integer[0, 4294967295]',
      desc: ' ',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'UInt32',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
  },
)
